From 3267907173e509ff8c4f560055cd2cbadcf2e260 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Sun, 24 Jan 2021 08:28:04 +0300
Subject: [PATCH 39/59] KAuth helper: use single KAuth action for all
 operations

Use single entry point for all package management operations.
Using single KAuth action allows user to enter his password only once
for all privileged operations during Discover session.
---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  | 91 ++++++++++---------
 .../AlpineApkBackend/AlpineApkAuthHelper.h    | 15 ++-
 .../org.kde.discover.alpineapkbackend.actions | 30 +-----
 3 files changed, 59 insertions(+), 77 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index e6e6cb7a1..97affc013 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -113,6 +113,7 @@ void AlpineApkAuthHelper::onTransactionError(const QString &msg)
     qCWarning(LOG_AUTHHELPER).nospace() << "ERROR occured in transaction \""
                                         << m_currentTransaction->desc()
                                         << "\": " << msg;
+    // construct error message to use in helper reply
     const QString errMsg = m_currentTransaction->desc() + QLatin1String(" failed: ") + msg;
     m_actionReply.setErrorDescription(errMsg);
     m_actionReply.setData({
@@ -129,16 +130,48 @@ void AlpineApkAuthHelper::onTransactionFinished()
     m_loop->quit();
 }
 
-ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
+// single entry point for all package management actions
+ActionReply AlpineApkAuthHelper::pkgmgmt(const QVariantMap &args)
 {
-    // return error by default
     m_actionReply = ActionReply::HelperErrorReply();
-
     HelperSupport::progressStep(0);
 
+    // actual package management action to perform is passed in "pkgAction" argument
+    if (!args.contains(QLatin1String("pkgAction"))) {
+        m_actionReply.setError(ActionReply::InvalidActionError);
+        m_actionReply.setErrorDescription(QLatin1String("Please pass \'pkgAction\' argument."));
+        HelperSupport::progressStep(100);
+        return m_actionReply;
+    }
+
+    const QString pkgAction = args.value(QLatin1String("pkgAction")).toString();
+
+    if (pkgAction == QStringLiteral("update")) {
+        update(args);
+    } else if (pkgAction == QStringLiteral("add")) {
+        add(args);
+    } else if (pkgAction == QStringLiteral("del")) {
+        del(args);
+    } else if (pkgAction == QStringLiteral("upgrade")) {
+        upgrade(args);
+    } else if (pkgAction == QStringLiteral("repoconfig")) {
+        repoconfig(args);
+    } else {
+        // error: unknown pkgAction
+        m_actionReply.setError(ActionReply::NoSuchActionError);
+        m_actionReply.setErrorDescription(QLatin1String("Please pass a valid \'pkgAction\' argument. "
+                                                        "Action \"%1\" is not recognized.").arg(pkgAction));
+    }
+
+    HelperSupport::progressStep(100);
+    return m_actionReply;
+}
+
+void AlpineApkAuthHelper::update(const QVariantMap &args)
+{
     if (!openDatabase(args)) {
         m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return m_actionReply;
+        return;
     }
 
     m_trans_ok = true;
@@ -155,27 +188,19 @@ ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
             { QLatin1String("updatesCount"), updatesCount }
         });
     }
-
-    HelperSupport::progressStep(100);
-    return m_actionReply;
 }
 
-ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
+void AlpineApkAuthHelper::add(const QVariantMap &args)
 {
-    // return error by default
-    m_actionReply = ActionReply::HelperErrorReply();
-
-    HelperSupport::progressStep(0);
-
     if (!openDatabase(args)) {
         m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return m_actionReply;
+        return;
     }
 
     const QString pkgName = args.value(QLatin1String("pkgName"), QString()).toString();
     if (pkgName.isEmpty()) {
         m_actionReply.setErrorDescription(QStringLiteral("Specify pkgName for adding!"));
-        return m_actionReply;
+        return;
     }
 
     m_trans_ok = true;
@@ -188,27 +213,19 @@ ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
     if (m_trans_ok) {
         m_actionReply = ActionReply::SuccessReply();
     }
-
-    HelperSupport::progressStep(100);
-    return m_actionReply;
 }
 
-ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
+void AlpineApkAuthHelper::del(const QVariantMap &args)
 {
-    // return error by default
-    m_actionReply = ActionReply::HelperErrorReply();
-
-    HelperSupport::progressStep(0);
-
     if (!openDatabase(args)) {
         m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return m_actionReply;
+        return;
     }
 
     const QString pkgName = args.value(QLatin1String("pkgName"), QString()).toString();
     if (pkgName.isEmpty()) {
         m_actionReply.setErrorDescription(QStringLiteral("Specify pkgName for removing!"));
-        return m_actionReply;
+        return;
     }
 
     const bool delRdepends = args.value(QLatin1String("delRdepends"), false).toBool();
@@ -228,20 +245,13 @@ ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
     if (m_trans_ok) {
         m_actionReply = ActionReply::SuccessReply();
     }
-
-    HelperSupport::progressStep(100);
-    return m_actionReply;
 }
 
-ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
+void AlpineApkAuthHelper::upgrade(const QVariantMap &args)
 {
-    m_actionReply = ActionReply::HelperErrorReply();
-
-    HelperSupport::progressStep(0);
-
     if (!openDatabase(args)) {
         m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return m_actionReply;
+        return;
     }
 
     bool onlySimulate = args.value(QLatin1String("onlySimulate"), false).toBool();
@@ -272,16 +282,10 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         replyData.insert(QLatin1String("onlySimulate"), onlySimulate);
         m_actionReply.setData(replyData);
     }
-
-    HelperSupport::progressStep(100);
-    return m_actionReply;
 }
 
-ActionReply AlpineApkAuthHelper::repoconfig(const QVariantMap &args)
+void AlpineApkAuthHelper::repoconfig(const QVariantMap &args)
 {
-    m_actionReply = ActionReply::HelperErrorReply();
-    HelperSupport::progressStep(10);
-
     if (args.contains(QLatin1String("repoList"))) {
         const QVariant v = args.value(QLatin1String("repoList"));
         const QVector<QtApk::Repository> repoVec = v.value<QVector<QtApk::Repository>>();
@@ -293,9 +297,6 @@ ActionReply AlpineApkAuthHelper::repoconfig(const QVariantMap &args)
     } else {
         m_actionReply.setErrorDescription(QStringLiteral("repoList parameter is missing in request!"));
     }
-
-    HelperSupport::progressStep(100);
-    return m_actionReply;
 }
 
 KAUTH_HELPER_MAIN("org.kde.discover.alpineapkbackend", AlpineApkAuthHelper)
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index 7fd69a8f3..240e6ed35 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -35,17 +35,22 @@ public:
     ~AlpineApkAuthHelper() override;
 
 public Q_SLOTS:
-    ActionReply update(const QVariantMap &args);
-    ActionReply add(const QVariantMap &args);
-    ActionReply del(const QVariantMap &args);
-    ActionReply upgrade(const QVariantMap &args);
-    ActionReply repoconfig(const QVariantMap &args);
+    // single entry point for all package management operations
+    ActionReply pkgmgmt(const QVariantMap &args);
 
 protected:
+    // helpers
     bool openDatabase(const QVariantMap &args, bool readwrite = true);
     void closeDatabase();
     void setupTransactionPostCreate(QtApk::Transaction *trans);
 
+    // individual pakckage management actions
+    void update(const QVariantMap &args);
+    void add(const QVariantMap &args);
+    void del(const QVariantMap &args);
+    void upgrade(const QVariantMap &args);
+    void repoconfig(const QVariantMap &args);
+
 protected Q_SLOTS:
     void reportProgress(float percent);
     void onTransactionError(const QString &msg);
diff --git a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
index 5f7f76771..c9bb5f9f2 100644
--- a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
+++ b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
@@ -1,29 +1,5 @@
-[org.kde.discover.alpineapkbackend.update]
-Name=Update repository index
-Description=Updates available packages list from repositories
-Policy=auth_admin
-Persistence=session
-
-[org.kde.discover.alpineapkbackend.upgrade]
-Name=Upgrade all upgradable packages
-Description=Upgrade installed packages to latest versions
-Policy=auth_admin
-Persistence=session
-
-[org.kde.discover.alpineapkbackend.add]
-Name=Install/upgrade package
-Description=Installs/upgrades one package
-Policy=auth_admin
-Persistence=session
-
-[org.kde.discover.alpineapkbackend.del]
-Name=Remove package
-Description=Uninstall one package
-Policy=auth_admin
-Persistence=session
-
-[org.kde.discover.alpineapkbackend.repoconfig]
-Name=Configure repositories
-Description=Configure repositories URLs
+[org.kde.discover.alpineapkbackend.pkgmgmt]
+Name=Package management
+Description=Install or remove packages, upgrade system
 Policy=auth_admin
 Persistence=session
-- 
GitLab


